/*
 *     Projected Grid Surfaces - grids.c  (demo version)
 *     Copyright (C) 1994, 1995  T.Hruz, I.Povazan, R.Gosiorovsky
 */

#include <math.h>
#include <stdio.h>

extern void (* Point)();

#define P11 0.577350269189       /* 1/sqrt(3) */

typedef float data_matrix;

int resol_x, resol_y;

double p11=P11;
double pxc[4]={P11,-P11,-P11,P11};
double pyc[4]={P11,P11,-P11,-P11};
double *vx1, *vy1, *vx2, *vy2;

double a11 = 0., a12 = 0., a13 = 0.;
double a21 = 0., a22 = 0., a23 = 0.;
double a31 = 0., a32 = 0., a33 = 0.;

double alfa_0 = 0., beta_0 = 0.;

double ax,ay;
double x_l,y_d,x_r,y_u;

int cur_x,cur_y;

int *contour_up;
int *contour_down;

/*
 *
 */

windoww(x_left,y_down,x_right,y_up)
double x_left,y_down,x_right,y_up;
 {
    ax=(resol_x-1)/(fabs(x_left-x_right));
    ay=(resol_y-1)/(fabs(y_down-y_up));
    x_l=x_left;
    y_d=y_down;
    x_r=x_right;
    y_u=y_up;
 }

/*___________________________________________________________________________*/

move(x,y)
double x,y;
 {
   d_move((int) floor((x-x_l)*ax),resol_y-1-(int) floor((y-y_d)*ay));
 }

/*___________________________________________________________________________*/

draw_c_x(x,y)
double x,y;
  {
    int xt,yt,cur_x_t,cur_y_t;

    xt = (int) floor((x-x_l)*ax);
    yt = resol_y-1-(int) floor((y-y_d)*ay);
    cur_x_t = cur_x;
    cur_y_t = cur_y;

    d_draw_c_down(xt,yt);
    d_move(cur_x_t,cur_y_t);
    d_draw_c_up(xt,yt);
  }

/*______________________________________________________________________*/

open_3d(reso_x,reso_y)
int reso_x,reso_y;
  {
	resol_x = reso_x;
	resol_y = reso_y;

	vx1 = (double *) malloc (resol_x * sizeof(double));
	vy1 = (double *) malloc (resol_y * sizeof(double));
	vx2 = (double *) malloc (resol_x * sizeof(double));
	vy2 = (double *) malloc (resol_y * sizeof(double));

	contour_up = (int *) malloc (resol_x * sizeof(int));
	contour_down = (int *) malloc (resol_x * sizeof(int));
  }

/*______________________________________________________________________*/

close_3d()
  {
     resol_x = 256;
     resol_y = 256;

     free(vx1);
     free(vy1);
     free(vx2);
     free(vy2);

     free(contour_up);
     free(contour_down);
  }

/*___________________________________________________________________________*/

d_move(d_x,d_y)
int d_x,d_y;
 {
   cur_x=d_x;
   cur_y=d_y;
 } 

/*___________________________________________________________________________*/

init_c_up()
 {
   int i;
   for (i=0;i<resol_x;i++)  contour_up[i]=resol_y-1;
 }

/*___________________________________________________________________________*/

init_c_down()
 {
   int i;
   for (i=0;i<resol_x;i++)  contour_down[i]=0;
 }

/*------------------------------------------------------------------------*/

#define ppoint(x_point,y_point) \
		if (y_point <= contour_up[x_point]) \
			{ \
			contour_up[x_point]=y_point; \
			Point(x_point,y_point); \
			}

d_draw_c_up(d_x,d_y)
int d_x,d_y;

{
int x_point,y_point;
int abs_dx,abs_dy;
int inc_1,inc_2,dd;
int exchange;

x_point=cur_x;
y_point=cur_y;

cur_x=d_x;
cur_y=d_y;

abs_dx=abs(x_point-d_x);
abs_dy=abs(y_point-d_y);

if (abs_dx==0)
	{
	if (abs_dy==0)
		{				/* point only */
		ppoint(x_point,y_point);
		cur_x=d_x;
		cur_y=d_y;
		return 0;
		}
		else
		{				/* vertical */
		if(y_point<d_y)
			{
			exchange=y_point;
			y_point=d_y;
			d_y=exchange;
			}
		abs_dy++;
		for(;abs_dy!=0;y_point--,abs_dy--)
			{
			ppoint(x_point,y_point);
			}
		}
	}
	else
	{
	if (abs_dy==0)
		{				/* horizontal */
		if(x_point>d_x)
			{
			exchange=x_point;
			x_point=d_x;
			d_x=exchange;
			}
		abs_dx++;
		for(;abs_dx!=0;x_point++,abs_dx--)
			{
			ppoint(x_point,y_point);
			}
		}
		else
		{
		if(abs_dx==abs_dy)	/* diagonal */
			{
			if(x_point>d_x)
				{
				exchange=x_point;
				x_point=d_x;
				d_x=exchange;
				exchange=y_point;
				y_point=d_y;
				d_y=exchange;
				}

			abs_dx++;
			if(y_point<d_y)
				{
				for(;abs_dx!=0;x_point++,y_point++,abs_dx--)
					{
					ppoint(x_point,y_point);
					}
				}
				else
				{
				for(;abs_dx!=0;x_point++,y_point--,abs_dx--)
					{
					ppoint(x_point,y_point);
					}
				}
			}
			else
			{	
                 	/* after three tests starts the general case */
			if(abs_dx>abs_dy)
				{
				inc_1=2*abs_dy;
				inc_2=2*(abs_dy-abs_dx);
				dd=2*abs_dy-abs_dx;
				abs_dx++;

				if(x_point>d_x)
					{
					exchange=y_point;
					y_point=d_y;
					d_y=exchange;
					exchange=x_point;
					x_point=d_x;
					d_x=exchange;
					}

				if(y_point<d_y)
					{
					while(abs_dx)	  /* x+1  y+1 */
						{
						ppoint(x_point,y_point);
						x_point++;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							y_point++;
							}
						abs_dx--;
						}
					}
					else
					{
					while(abs_dx)	  /* x+1  y-1 */
						{
						ppoint(x_point,y_point);
						x_point++;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							y_point--;
							}
						abs_dx--;
						}
					}
				}
				else
				{
				inc_1=2*abs_dx;
				inc_2=2*(abs_dx-abs_dy);
				dd=2*abs_dx-abs_dy;
				abs_dy++;

				if(y_point<d_y)
					{
					exchange=y_point;
					y_point=d_y;
					d_y=exchange;
					exchange=x_point;
					x_point=d_x;
					d_x=exchange;
					}

				if(x_point<d_x)
					{
					while(abs_dy)	   /* y-1  x+1 */
						{
						ppoint(x_point,y_point);
						y_point--;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							x_point++;
							}
						abs_dy--;
						}
					}
					else
					{
					while(abs_dy)	   /* y-1  x-1 */
						{
						ppoint(x_point,y_point);
						y_point--;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							x_point--;
							}
						abs_dy--;
						}
					}
				}
			}
		}
	}
}

/*___________________________________________________________________________*/

#undef ppoint
#define ppoint(x_point,y_point) \
		if (y_point >= contour_down[x_point]) \
			{ \
			contour_down[x_point]=y_point; \
			Point(x_point,y_point); \
			}

d_draw_c_down(d_x,d_y)
int d_x,d_y;

{
int x_point,y_point;
int abs_dx,abs_dy;
int inc_1,inc_2,dd;
int exchange;

x_point=cur_x;
y_point=cur_y;

cur_x=d_x;
cur_y=d_y;

abs_dx=abs(x_point-d_x);
abs_dy=abs(y_point-d_y);

if (abs_dx==0)
	{
	if (abs_dy==0)
		{				/* point only */
		ppoint(x_point,y_point)
		cur_x=d_x;
		cur_y=d_y;
		return 0;
		}
		else
		{				/* vertical */
		if(y_point>d_y)
			{
			exchange=y_point;
			y_point=d_y;
			d_y=exchange;
			}
		abs_dy++;
		for(;abs_dy!=0;y_point++,abs_dy--)
			{
			ppoint(x_point,y_point)
			}
		}
	}
	else
	{
	if (abs_dy==0)
		{				/* horizontal */
		if(x_point>d_x)
			{
			exchange=x_point;
			x_point=d_x;
			d_x=exchange;
			}
		abs_dx++;
		for(;abs_dx!=0;x_point++,abs_dx--)
			{
			ppoint(x_point,y_point)
			}
		}
		else
		{
		if(abs_dx==abs_dy)	/* diagonal */
			{
			if(x_point>d_x)
				{
				exchange=x_point;
				x_point=d_x;
				d_x=exchange;
				exchange=y_point;
				y_point=d_y;
				d_y=exchange;
				}

			abs_dx++;
			if(y_point<d_y)
				{
				for(;abs_dx!=0;x_point++,y_point++,abs_dx--)
					{
					ppoint(x_point,y_point)
					}
				}
				else
				{
				for(;abs_dx!=0;x_point++,y_point--,abs_dx--)
					{
					ppoint(x_point,y_point)
					}
				}
			}
			else
			{	
                	/* after three tests starts the general case */
			if(abs_dx>abs_dy)
				{
				inc_1=2*abs_dy;
				inc_2=2*(abs_dy-abs_dx);
				dd=2*abs_dy-abs_dx;
				abs_dx++;

				if(x_point>d_x)
					{
					exchange=y_point;
					y_point=d_y;
					d_y=exchange;
					exchange=x_point;
					x_point=d_x;
					d_x=exchange;
					}

				if(y_point<d_y)
					{
					while(abs_dx)	   /* x+1  y+1 */
						{
						ppoint(x_point,y_point)
						x_point++;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							y_point++;
							}
						abs_dx--;
						}
					}
					else
					{
					while(abs_dx)	    /* x+1  y-1 */
						{
						ppoint(x_point,y_point)
						x_point++;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							y_point--;
							}
						abs_dx--;
						}
					}
				}
				else
				{
				inc_1=2*abs_dx;
				inc_2=2*(abs_dx-abs_dy);
				dd=2*abs_dx-abs_dy;
				abs_dy++;

				if(y_point>d_y)
					{
					exchange=y_point;
					y_point=d_y;
					d_y=exchange;
					exchange=x_point;
					x_point=d_x;
					d_x=exchange;
					}

				if(x_point<d_x)
					{
					while(abs_dy)	    /* y+1  x+1 */
						{
						ppoint(x_point,y_point)
						y_point++;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							x_point++;
							}
						abs_dy--;
						}
					}
					else
					{
					while(abs_dy)	   /* y+1  x-1 */
						{
						ppoint(x_point,y_point)
						y_point++;
						if(dd<0)
							{
							dd+=inc_1;
							}
							else
							{
							dd+=inc_2;
							x_point--;
							}
						abs_dy--;
						}
					}
				}
			}
		}
	}
}
/*-------------------------------------------------------------------------*/

set_transform_parallel_1(alfap,betap)
double alfap,betap;
	{
	double alfa_1,beta_1,cosa1,cosa0,sina1,sina0,cosb1_0,sinb1_0;

	alfa_1 = (M_PI/180.)*alfap;
	beta_1 = (M_PI/180.)*betap;

	cosb1_0 = cos(beta_1 - beta_0);
	sinb1_0 = sin(beta_1 - beta_0);
	cosa0 = cos(alfa_0);
	sina0 = sin(alfa_0);
	cosa1 = cos(alfa_1);
	sina1 = sin(alfa_1);

	a11 = cosa0 * cosa1 * cosb1_0 + sina1 * sina0;
	a21 = -sinb1_0 * cosa0;
	a31 = cosa0 * sina1 * cosb1_0 - cosa1 * sina0;

	a12 = cosa1 * sinb1_0;
	a22 = cosb1_0;
	a32 = sina1 * sinb1_0;

	a13 = sina0 * cosa1 * cosb1_0 - cosa0 * sina1;
	a23 = -sina0 * sinb1_0;
	a33 = sina0 * sina1 * cosb1_0 + cosa0 * cosa1;

	alfa_0 = alfa_1;
	beta_0 = beta_1;
	}

/*___________________________________________________________________________*/

double px(x,y,z)
double x,y,z;
  {
    return (a21*x+a22*y+a23*z);
  }

/*___________________________________________________________________________*/

double py(x,y,z)
double x,y,z;
  {
     return (-(a11*x+a12*y+a13*z));
  }

/*___________________________________________________________________________*/

double *normalize(f,nx,ny)
data_matrix f[];
int nx,ny;
  {
     int i;
     double max;

     max = 0.;
     for (i = 0; i < nx * ny ; i++)
   	if (max < fabs((double) f[i]))  max = fabs((double) f[i]);

     for (i = 0; i < nx * ny ; i++)  f[i] = (double) f[i] * p11 / max;
  }

/*-----------------------------------------------------------------------*/

function1(f,nx,ny,alfa,beta)
data_matrix f[];
int nx,ny;
double alfa,beta;
   {
	int i,j;
	double nxf,nyf;
	double x,y,xk,yk,pom,miny;
	int ix,iy,ixk,iyk,ixd,iyd,ident;
	int test_beta;

	set_transform_parallel_1(0.,0.);
	set_transform_parallel_1(alfa,beta);

	if (cos((M_PI/180.)*alfa) >= 0.)
		{
		miny=1.;ident=0;
		for (i=0;i<4;i++)
			{
			if (miny>(pom=py(pxc[i],pyc[i],0.)))
				{
				miny=pom;
				ident=i;
				}
			}
		}
	else
		{
		miny= -1.;ident= 0;
		for (i=0;i<4;i++)
			{
			if (miny<(pom=py(pxc[i],pyc[i],0.)))
				{
				miny=pom;
				ident=i;
				}
			}
		}

	switch (ident)
		{
		case 0:
			nxf= -2.*p11/(nx-1);
			nyf= -2.*p11/(ny-1);
			x= xk= p11;y= yk= p11;
			ix= ixk= 0;iy= iyk= 0;
			ixd= 1;iyd= 1;
			break;
		case 1:
			nxf= 2.*p11/(nx-1);
			nyf= -2.*p11/(ny-1);
			x= xk= -p11;y= yk= p11;
			ix= ixk= nx-1;iy= iyk= 0;
			ixd= -1;iyd= 1;
			break;
		case 2:
			nxf= 2.*p11/(nx-1);
			nyf= 2.*p11/(ny-1);
			x= xk= -p11;y= yk= -p11;
			ix= ixk= nx-1;iy= iyk= ny-1;
			ixd= -1;iyd= -1;
			break;
		case 3:
			nxf= -2.*p11/(nx-1);
			nyf= 2.*p11/(ny-1);
			x= xk= p11;y= yk= -p11;
			ix= ixk= 0;iy= iyk= ny-1;
			ixd= 1;iyd= -1;
			break;
		}

	test_beta = beta_view(beta);

	init_c_up();
	init_c_down();

	if (!test_beta)
		{
		for (j=0;j<ny;j++)
			{
			vx1[j]=px(xk,yk,(double) f[mapp(nx,ny,ixk,iyk)]);
			vy1[j]=py(xk,yk,(double) f[mapp(nx,ny,ixk,iyk)]);
			yk=yk+nyf;
			iyk=iyk+iyd;
			}
		yk=y;
		iyk=iy;

		move(vx1[0],vy1[0]);
		for (j=1;j<ny;j++)
			{
			draw_c_x(vx1[j],vy1[j]);
			}

		for (i=0;i<nx-1;i++)
			{
			for (j=0;j<ny;j++)
				{
		vx2[j]=px(xk+nxf,yk,(double) f[mapp(nx,ny,ixk+ixd,iyk)]);
		vy2[j]=py(xk+nxf,yk,(double) f[mapp(nx,ny,ixk+ixd,iyk)]);
				yk=yk+nyf;
				iyk=iyk+iyd;
				}
			move(vx1[0],vy1[0]);
			draw_c_x(vx2[0],vy2[0]);
			for (j=1;j<ny;j++)
				{
				move(vx1[j],vy1[j]);
				draw_c_x(vx2[j],vy2[j]);
				draw_c_x(vx2[j-1],vy2[j-1]);
				}
			for (j=0;j<ny;j++)
				{
				vx1[j]=vx2[j];vy1[j]=vy2[j];
				}
			xk=xk+nxf;
			yk=y;
			ixk=ixk+ixd;
			iyk=iy;
			}
		}
	else
		{
		for (j=0;j<nx;j++)
			{
			vx1[j]=px(xk,yk,(double) f[mapp(nx,ny,ixk,iyk)]);
			vy1[j]=py(xk,yk,(double) f[mapp(nx,ny,ixk,iyk)]);
			xk=xk+nxf;
			ixk=ixk+ixd;
			}
		xk=x;
		ixk=ix;

		move(vx1[0],vy1[0]);
		for (j=1;j<nx;j++)
			{
			draw_c_x(vx1[j],vy1[j]);
			}

		for (i=0;i<ny-1;i++)
			{
			for (j=0;j<nx;j++)
				{
  	         vx2[j]=px(xk,yk+nyf,(double) f[mapp(nx,ny,ixk,iyk+iyd)]);
	         vy2[j]=py(xk,yk+nyf,(double) f[mapp(nx,ny,ixk,iyk+iyd)]);
				xk=xk+nxf;
				ixk=ixk+ixd;
				}
			move(vx1[0],vy1[0]);
			draw_c_x(vx2[0],vy2[0]);
			for (j=1;j<nx;j++)
				{
				move(vx1[j],vy1[j]);
				draw_c_x(vx2[j],vy2[j]);
				draw_c_x(vx2[j-1],vy2[j-1]);
				}
			for (j=0;j<nx;j++)
				{
				vx1[j]=vx2[j];vy1[j]=vy2[j];
				}
			yk=yk+nyf;
			xk=x;
			iyk=iyk+iyd;
			ixk=ix;
			}
		}
      }

/*___________________________________________________________________________*/

mapp(nx,ny,ix,iy)
int nx,ny,ix,iy;
  {
     return (ix*nx+iy);
  }

/*___________________________________________________________________________*/

beta_view(beta)
double beta;
   {
	if  (	((  45.<= beta) && (beta <=  90.)) ||
		(( 135.<  beta) && (beta <  180.)) ||
		(( 225.<= beta) && (beta <= 270.)) ||
		(( 315.<= beta) && (beta <  360.)) )
		{
		  return (1);
		}
	else
		{
		  return (0);
		}
   }

/*--------------------------------------------------------------------------*/

data_matrix a[10000];
double x,y,deltax,deltay,pom1,pom2;
int i,j;

Grid1(int r_x,int r_y,int density,double alfa,double beta)
{
   x= -6.;
   y= -6.;

   deltax= 12./(density-1.);
   deltay= 12./(density-1.);

   for (i=0;i<density;i++)
	{
	y= -6.;
	for(j=0;j<density;j++)
		{
		pom2= sqrt(x*x+y*y);
                if (pom2<3) pom1= 3-pom2;  
           /*     if ((fabs(x)<3)&&(fabs(y)<3)) pom1=3;  */
                else pom1=0; 
		a[mapp(density,density,density - i,density - j)]=pom1;
		y=y+deltay;
		}
	x=x+deltax;
	}

   normalize(a,density,density);

   open_3d(r_x, r_y);
   windoww(-1.,-1.,1.,1.);
   function1(a,density,density,alfa,beta);
   close_3d();
 }

/*------------------------------------------------------------------------*/

Grid2(int r_x,int r_y,int density,double alfa,double beta)
{
   x= -3.;
   y= -3.;

   deltax= 6./(density-1.);
   deltay= 6./(density-1.);

   for (i=0;i<density;i++)
	{
	y= -3.;
	for(j=0;j<density;j++)
		{
		pom1= -0.7*exp(-((x-0.9)*(x-0.9)+(y-0.9)*(y-0.9)));
		pom2= exp(-((x+0.9)*(x+0.9)+(y+0.9)*(y+0.9)));
		a[mapp(density,density,density - i,density - j)]=pom1+pom2;
		y=y+deltay;
		}
	x=x+deltax;
	}
   normalize(a,density,density);

   open_3d(r_x, r_y);
   windoww(-1.,-1.,1.,1.);
   function1(a,density,density,alfa,beta);
   close_3d();
 }

/*------------------------------------------------------------------------*/

Grid3(int r_x,int r_y,int density,double alfa,double beta)
{
   x= -12.;
   y= -12.;

   deltax= 24./(density-1.);
   deltay= 24./(density-1.);

   for (i=0;i<density;i++)
	{
	y= -12.;
	for(j=0;j<density;j++)
		{
                pom2= sqrt(x*x+y*y);
                if (pom2==0) pom1= 1;
		else pom1 = sin(pom2)/pom2;
		a[mapp(density,density,density - i,density - j)] = pom1;
		y=y+deltay;
		}
	x=x+deltax;
	}
   normalize(a,density,density);

   open_3d(r_x, r_y);
   windoww(-1.,-1.,1.,1.);
   function1(a,density,density,alfa,beta);
   close_3d();
 }

/*------------------------------------------------------------------------*/

